#! /bin/bash

if [ $# -lt 3 ]
then
        echo "$0 <max-age> <max-files> <dirname>..."
        echo "   <max-age>    eta' massima dei file in giorni (basata sulla data di modifica)"
        echo "   <max-files>  numero massimo di file da lasciare nella directory"
        echo "   <dirname>... sequenza di directory da ripulire"
	exit 1
fi

maxAge=$1
shift
fileLimit=$1
shift
# $@ contiene la sequenza di directory

# Cancella i file modificati da piu' di maxAge giorni
find $@ -type f -mtime +$maxAge -delete

# Mantiene i fileLimit file più recenti
# 1) cerca i file ordinari nelle directory e stampa il timestam e il percorso completo
# 2) ordina in modo lessicografico (i meno recenti per prima perche' le righe dell'input di sort
#    iniziano per il timestamp)
# 3) stampa tutte le righe tranne le ultime fileLimit
# 4) rimuovi il campo timestamp
# 5) cancella i file (-f per evitare gli errori se non ci sono file)
find $@ -type f -printf '%TY-%Tm-%Td-%CH%CM %p\n' | sort | head -n -${fileLimit} | cut -d' ' -f2 | xargs rm -f
